#include<stdio.h>
int re[1000001];
int main()
{long h,n;

int a,a1,buff=0,flg;

	scanf("%ld %ld",&h,&n);
	for(int j =1;j<n+1;j++)
	re[j]=1;
	
	for(int i =1;i<h+1;i++)
	{
		for(int j =1;j<n+1;j++)
		{
		
		scanf("%d",&a);
		
		//leva strana
			if(j==1&&a==0)
			{flg=0;
			buff=buff+re[1];
			
			re[1]=0;
			}
			
			// desna strana
			else if(j==n&&a==0)
			{	if(a1==1)
				flg=n-1;
				re[flg]=re[flg]+buff+re[n];
				buff=0;
				re[n]=0;

			}	
			//naisli na stenu sa leve strane
			else if(a==1&&a1==0)
			{   if(flg==0)
				{re[j]=re[j]+buff;
				buff=0;
				}
				else if(buff%2==0)
				{re[flg]=re[flg]+buff/2;
				re[j]=re[j]+buff/2;
				buff=0;
				}
				else if (i%2==0)
				{re[flg]=re[flg]+buff/2;
				re[j]=re[j]+buff/2+1;
				buff=0;
				}
				else
				{re[flg]=re[flg]+buff/2+1;
				re[j]=re[j]+buff/2;
				buff=0;
				}
				
				
				
			}
			else if(a==0&&a1==1)
			{
			flg=j-1;
			buff=buff+re[j];
			re[j]=0;
			}
			else if(a==0&&a1==0)
			{
			buff=buff+re[j];
			re[j]=0;
			}
		
				
			
			
			a1=a;
		}
	}
	
	
	
	for(int j =1;j<n+1;j++)
	printf("%d ",re[j]);
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	return 0;
}